;;; lisp file for xyzzy ver0.2.2.233
;;; convert-space.l ver.0.0.0.2 // crayonzen [2006-06-16]12:15:29(+0900)

(provide "convert-space")

(in-package "editor")

(export '(get-selection-or-region-point-value
	  get-selection-or-region-point-value-rotatef

	  convert-tab-to-space
	  convert-space-to-tab
	  convert-byte2space-to-space
	  convert-space-to-byte2space-ask
	  convert-space-to-byte2space
	  convert-tab_byte2sapce-to-space

	  convert-left_space_tab_byte2space-to-indent
	  convert-left_space_tab_byte2space-to-space
	  convert-left_space_tab_byte2space-to-byte2space
	  convert-left_space_tab_byte2space-to-byte2space-ask
	  ;convert-left_space_tab_byte2space-to

	  *convert-space-menus*
	  init-convert-space-menu
	  ))

(export '(
	  delete-blank-lines-selection
	  delete-blank-lines-selection-complete
	  delete-blank-lines-complete
	  delete-same-line

	  *delete-blank-lines-menus*
	  init-delete-blank-lines-menu
	  ))

;;;;;;;;;;;;;;;; convert space tab byte2space (selection or region)
(defun get-selection-or-region-point-value ()
  (interactive "p")
  (setq markp nil) (setq cursorp nil)
  (if (pre-selection-p)
      (progn (setq markp (selection-mark)) (setq cursorp (selection-point)))
    (progn (setq markp (mark nil)) (setq cursorp (point))))
  (values markp cursorp) ;(list markp cursorp)
  )

(defun get-selection-or-region-point-value-rotatef ()
  (interactive "p")
  (multiple-value-setq (startp endp) (get-selection-or-region-point-value))
  (if (> startp endp)
      (progn (rotatef startp endp) (setq rotatevalue t))
    (setq rotatevalue nil)
    )
  (values startp endp rotatevalue)
  )

;(map-selection #'untabify))
;(defun untabify (from to)
;(defun untabify-selection ()
(defun convert-tab-to-space ()
  (interactive "*p")
  (multiple-value-setq (startp endp rotatevalue) (get-selection-or-region-point-value-rotatef))
  (let ((tab-columns (tab-columns (selected-buffer))))
    (save-excursion
      (save-restriction
	(narrow-to-region startp endp)
	(goto-char (point-min))
	(while (scan-buffer "\t")
	  (setq p (- tab-columns (rem (current-column) tab-columns)))
	  (insert #\SPC p)
	  (delete-char)
	  )
	)
      )
    )
  t)

;(map-selection #'tabify))
;(defun tabify (from to)
;(defun tabify-selection ()
(defun convert-space-to-tab ()
  (interactive "*p")
  (multiple-value-setq (startp endp rotatevalue) (get-selection-or-region-point-value-rotatef))
  (tabify startp endp);tabify -> select.l
  )

(defun convert-byte2space-to-space ()
  (interactive "*p")
  (multiple-value-setq (startp endp rotatevalue) (get-selection-or-region-point-value-rotatef))
  (let ((tab-columns (tab-columns (selected-buffer))))
    (save-excursion
      (save-restriction
	(narrow-to-region startp endp)
	(goto-char (point-min))
	(while (scan-buffer "@")
	  (insert #\SPC 2)
	  (delete-char)
	  )
	)
      )
    )
  t)

(defun convert-space-to-byte2space-ask ()
  (interactive "*p")
  (setq change1space nil)
  (when (yes-or-no-p "p߰uPv̂ϊ܂H")
    (setq change1space t))
  (convert-space-to-byte2space change1space)
  )

(defun convert-space-to-byte2space(&optional (change1space t))
  (interactive "*p")
  (multiple-value-setq (startp endp rotatevalue) (get-selection-or-region-point-value-rotatef))
  (let ((tab-columns (tab-columns (selected-buffer))))
    (save-excursion
      (save-restriction
	(narrow-to-region startp endp)
	(goto-char (point-min))
	(while (scan-buffer "  ")
	  (insert "@")
	  (delete-char 2)
	  )
	(when change1space
	  (goto-char (point-min))
	  (while (scan-buffer " ")
	    (insert "@")
	    (delete-char)
	    )
	  )
	)
      )
    )
  t)

(defun convert-tab_byte2sapce-to-space ()
  (interactive "*p")
  (if (pre-selection-p)
      (progn
	(setq startp (selection-mark))
	(setq endp (selection-point)))
    (progn
      (setq startp (mark nil))
      (setq endp (point))))
  (if (> startp endp)
      (rotatef startp endp))
  (let ((tab-columns (tab-columns (selected-buffer))))
    (save-excursion
      (goto-char startp)
      (while (scan-buffer "\t")
	(if (>= (point) endp) (return))
	(setq p (- tab-columns (rem (current-column) tab-columns)))
	(insert #\SPC p)
	(delete-char)
	(setq endp (1- (+ endp p)))
	)
      (goto-char startp)
      (while (scan-buffer "@")
	(if (>= (point) endp) (return))
	(insert #\SPC 2)
	(delete-char)
	(setq endp (1+ endp))
	)))
  t)

;;;;;;;;;;;;;;;; convert left space only (selection or region)
;1 indent(tab + space) ;2 space ;3 byte2space &optional
(defun convert-left_space_tab_byte2space-to-indent ()
  (interactive "*")
  (convert-left_space_tab_byte2space-to 1 nil)
  )

(defun convert-left_space_tab_byte2space-to-space ()
  (interactive "*")
  (convert-left_space_tab_byte2space-to 2 nil)
  )

(defun convert-left_space_tab_byte2space-to-byte2space ()
  (interactive "*")
  (convert-left_space_tab_byte2space-to 3 t)
  )

(defun convert-left_space_tab_byte2space-to-byte2space-ask ()
  (interactive "*")
  (setq one_column nil)
  (when (yes-or-no-p "P]ꍇP₷Hi͂P폜j")
    (setq one_column t))
  (convert-left_space_tab_byte2space-to 3 one_column)
  )

(defun convert-left_space_tab_byte2space-to (inchar &optional one_column)
  (interactive "*")
  (multiple-value-setq (from to) (get-selection-or-region-point-value))
  (save-excursion
    (goto-char to)
    (setq tolinenum (current-line-number)))
  (if (> from to)
      (rotatef from to))
  (save-restriction
    (setq sp (progn
	       (goto-char from) (goto-bol)
	       (point)))
    (setq ep (progn
	       (goto-char to) (goto-eol)
	       (point)))
    (narrow-to-region sp ep)
    (goto-char (point-min))
    (while (not (eobp))
      (delete-region (point)
		     (progn
		       (skip-chars-forward " \t@")
		       (setq ccnum (current-column))
		       (point)))
      (when (plusp ccnum)
	(case inchar
	  (1 (indent-to ccnum));tab + space
	  (2 (insert #\SPC ccnum))
	  (3 (multiple-value-bind (q r) (truncate ccnum 2)
	       (insert"@" q)
	       (if (and one_column (= r 1))
		   (insert"@"))
	       )
	     )
	  )
	)
      (unless (forward-line 1)
	(return))
      )
    )
  (goto-line tolinenum)
  t)

;;;]ȋ󔒍s͏ (&optional arg = t 󔒍s͊Sɏ)
(defun delete-blank-lines-selection (&optional arg)
  (interactive "*")
  (multiple-value-setq (from to rotatevalue) (get-selection-or-region-point-value-rotatef))
  ;;  (cond ((pre-selection-p)
  ;;	 (setq from (selection-mark))
  ;;	 (setq to (selection-point)))
  ;;	(t
  ;;	 (setq from (point-min))
  ;;	 (setq to (point-max))))
  ;;  (if (> from to)
  ;;      (rotatef from to))
  (save-excursion
    (save-restriction
      (narrow-to-region from to)
      (let (mline)
	(goto-char (point-min))
	(setq nline (current-line-number))
	(setq count 0)
	(while t
	  (goto-line nline)
	  (if arg
	      (delete-blank-lines-complete)
	    (delete-blank-lines))
	  (incf nline)
	  (goto-char (point-max))
	  (if (>= nline (current-line-number))
	      (return))
	  )
	)
      ))
  )

;;;󔒍s͊Sɏ
(defun delete-blank-lines-selection-complete ()
  (interactive "*")
  (delete-blank-lines-selection t)
  )

;;;change 1byte: " \t@" -> " \t"
(defun delete-blank-lines-complete ()
  (interactive "*")
  (save-excursion
    (skip-chars-backward " \t\n@")
    (goto-eol)
    (setq from (point) fromnum (current-line-number))
    (skip-chars-forward " \t\n@")
    (goto-bol)
    (setq to (point) tonum (current-line-number)))
  (when (> (- tonum fromnum) 1)
    (delete-region from to)
    (insert #\LFD 1)
    (forward-char -1)
    )
  )

;;;ẽC͏
(defun delete-same-line (&optional buffer pstart pend)
  (interactive "*")
  (long-operation
    (when buffer
      (set-buffer buffer))
    (unless (or pstart pend)
      (multiple-value-setq (pstart pend rotatevalue) (get-selection-or-region-point-value-rotatef)))
    ;;      (cond ((pre-selection-p)
    ;;	     (setq pstart (selection-mark))
    ;;	     (setq pend (selection-point)))
    ;;	    (t
    ;;	     (setq pstart (point-min))
    ;;	     (setq pend (point-max)))))
    (if (> pstart pend)
	(rotatef pstart pend))

    (save-excursion
      (goto-char pstart)
      (goto-bol)
      (setq spoint (point))
      (setq sline (current-line-number))
      (goto-char pend)
      (goto-eol)
      (setq epoint (point))
      (setq eline (current-line-number))
      (save-restriction
	(narrow-to-region spoint epoint)
	(let (mline)
	  (goto-char (point-min))
	  (setq nline (current-line-number))
	  (setq count 0)
	  (while t
	    (goto-line nline)
	    (setq str1 (buffer-substring (progn
					   (goto-bol)
					   (point))
					 (progn
					   (goto-eol)
					   (point))))
	    (while (scan-buffer str1 :limit (point-max))
	      (setq str2 (buffer-substring (progn
					     (goto-bol)
					     (point))
					   (progn
					     (goto-eol)
					     (point))))
	      (when (string-equal str1 str2)
		(delete-region (progn (goto-bol) (point))
			       (progn (goto-eol) (point)))
		(delete-char 1)
		(incf count)
		(message "ײ: ~S / ~S 폜: ~S" nline eline count)))
	    (incf nline)
	    (goto-char (point-max))
	    (if (>= nline (current-line-number))
		(return))
	    )
	  (message "ײ ~S  ~Si폜 ~S j܂ł̍폜: ~S" sline eline nline count)
	  (goto-char (point-min))
	  ))))
  )

;;;;;;;;;;;;;;;;menu
(defvar *convert-space-menus* nil)

(defun init-convert-space-menu ()
  (or *convert-space-menus*
      (setq *convert-space-menus* (create-popup-menu)))

  (setq *convert-space-menus*
	(define-popup-menu
	  (:item nil " -> ߰(&S)"
	   'convert-tab-to-space)
	  (:item nil "߰ -> (&T)"
	   'convert-space-to-tab)
	  (:item nil "Sp߰ -> ߰(&E)"
	   'convert-byte2space-to-space)
	  (:item nil "߰ -> Sp߰(&J)"
	   'convert-space-to-byte2space-ask)
	  :sep
	  (:item nil "ށSp߰ -> ߰(&A)"
	   'convert-tab_byte2sapce-to-space)
	  :sep
	  (:item nil "̋󔒂̂[߰EށESp߰] -> [tab+space](&I)"
	   'convert-left_space_tab_byte2space-to-indent)
	  (:item nil "̋󔒂̂[߰EށESp߰] -> ߰(&C)"
	   'convert-left_space_tab_byte2space-to-space)
	  (:item nil "̋󔒂̂[߰EށESp߰] -> Sp߰(&Z)"
	   'convert-left_space_tab_byte2space-to-byte2space-ask)
	  ))
  )

(defvar *delete-blank-lines-menus* nil)

(defun init-delete-blank-lines-menu ()
  (or *delete-blank-lines-menus*
      (setq *delete-blank-lines-menus* (create-popup-menu)))
  (setq *delete-blank-lines-menus*
	(define-popup-menu
	  (:item :tag-command "]ȋ󔒍s͏(&B)"
	   'delete-blank-lines-selection)
	  (:item :tag-command "Sɋ󔒍s(&F)"
	   'delete-blank-lines-selection-complete)
	  (:item :tag-command "eײ݂͏(&D)"
	   'delete-same-line)
	  )
	)
  )

(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-convert-space-menu)
	      (init-delete-blank-lines-menu)
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::edit))))
	      (add-menu-separator menu 'conver-space-sep)
	      (add-popup-menu menu *convert-space-menus* "󔒁`ϊ(&S)")
	      (add-popup-menu menu *delete-blank-lines-menus* "󔒍sFe`폜(&B)")
	      ))

;;;;;;;;;;;;;;;; }j[Q@insert menu edit ҏW
;;(add-hook '*init-app-menus-hook*
;;	  #'(lambda ()
;;	      (init-convert-space-menu)
;;	      (init-delete-blank-lines-menu)
;;	      (when (and *app-menu*
;;			 (setq menu (get-menu *app-menu* 'ed::edit))))
;;	      (setq ip -1)
;;	      (while (get-menu menu (incf ip) t))
;;
;;	      (insert-menu-separator menu ip 'conver-space-sep)
;;	      (insert-popup-menu menu (incf ip) *convert-space-menus* "󔒁`ϊ(&W)")
;;	      (insert-popup-menu menu (incf ip) *delete-blank-lines-menus* "󔒍sFe`폜(&B)")
;;	      )
;;	  )
