;;; lisp file for xyzzy ver0.2.2.233
;;; make-html-lisp.l ver.0.0.1.2 // crayonzen [2005-03-23]10:41:01(+0900)

;// how-to: load
;//       : write in .xyzzy or siteinit.l
;(load-library "make-htm-lisp")

;;; M-x: make-lisp-to-html ;;; M-x: make-lisp-to-html-css

(provide "make-html-lisp")

(in-package "editor")

(export '(make-lisp-to-html
	  make-lisp-to-html-css
	  make-lisp-to-html-buffer-all
	  make-lisp-to-html-css-buffer-all
	  make-lisp-to-html-pre-exchange
	  make-lisp-to-html-copyright-exchange
	  make-lisp-tool-html-to-text
	  make-lisp-tool-html-to-text-leave-link

	  make-lisp-tool-convert-br-to-return
	  make-lisp-tool-convert-return-to-br
	  make-lisp-tool-indent-space-to-&nbsp
	  make-lisp-tool-p-to-br-for-claris
	  make-lisp-tool-pre-to-&nbsp-br
	  ))

(defvar *lisp-html-name-created* "crayonzen") ;;your name
(defvar *lisp-html-name-generator* "make-html-lisp")

(defvar *lisp-html-copyright* t)
(defvar *lisp-html-name-copyright* "2000-2006 CrayonZen") ;;copyright year & name

;;(defvar *lisp-html-link-href* "http://homepage2.nifty.com/crayon/") ;;your homepage address
;;(defvar *lisp-html-link-name* "HOME")

(defvar *lisp-convert-tab-to-space* t) ;;convert tab to space

;;;t = indent space "&nbsp;" return "<br>"
;;;nil = PRE - Preformatted Text
(defvar *lisp-convert-indent-space* nil)

;;;html-to-text-leave-link & add PRE (*lisp-convert-indent-space* nil)

;;;;;;;;;;;;;;;;link
(defun get-lisp-html-link (buffer)
  (let (concatlink)
    (setq linklist '(("http://homepage2.nifty.com/crayon/" . "HOME") ;;your homepage address
		     ("http://homepage2.nifty.com/crayon/xyzzy-index.htm" . "xyzzy") ;;else link
		     ;("http://" . "name1") ;;else link
		     ;( nil . "name2") ;;no link
		     ))
    (dolist (item linklist)
      (setq address (car item))
      (setq name (cdr item))
      (if address
	  (setq link (format nil "~A~A~S~A~A~A"
			     " &gt; " "<a href=" address ">" name "</a>"))
	(setq link (format nil "~A~A"
			   " &gt; " name)))
      (setq concatlink (concat concatlink link))
      )
    (setq title (pathname-name (buffer-name buffer)))
    (setq link (format nil "~A~A" " &gt; " title))
    (setq concatlink (concat concatlink link)) ;;insert this page title
    ;(format t "~A" concatlink)
    concatlink)
  )

;;;;;;;;;;;;;;;;style
;;;color : #000000; color : #008000; ;;;else #408080;
(defun get-lisp-html-style (&optional type)
  (let (style)
    (setq stylehtml1 (format nil "~A~S~A~%~A~%"
			     "<style type=" "text/css" ">"
			     "<!--"))
    (setq stylebody (format nil "~A~%~A~%~A~S~A~%~A~%~A~%~A~%"
			    "body {"
			    "     color : #408080;"
			    "     font-family : " "lr SVbN" ";"
			    "     font-size : medium;"
			    "     background-color : #FFFFFF;"
			    "}"))
    (setq stylecomment (format nil "~A~%~A~%~A~%"
			       "span.comment {"
			       "     color : #008000;"
			       "}"))
    (setq stylehtml2 (format nil "~A~%~A~%"
			     "-->"
			     "</style>"))

    (setq stylecsshtml (format nil "~A~S~A~S~A~S~A~%"
			       "<link href=" "./stylelisp.css" " type=" "text/css" " rel=" "stylesheet" ">"))
    (setq stylecss1 (format nil "~A~%"
			    "/* lisppX^C */"))

    (case type
      (1 (setq style (concat stylehtml1 stylebody stylecomment stylehtml2))) ;;style html
      (2 (setq style (concat stylecsshtml))) ;;stylecss html
      (3 (setq style (concat stylecss1 stylebody stylecomment))) ;;stylecss file
      (t (setq style (concat stylebody stylecomment))) ;;style
      )
    style)
  )

;(setq style (get-lisp-html-style 1))
;(format t "~A" style)
;(insert style)

;;;;;;;;;;;;;;;;main
(defun make-lisp-to-html-save-directory ()
  (let (savedirectory)
    (setq path (map-backslash-to-slash (get-special-folder-location :desktop)))
    (setq folder "make_lisp_html")
    (setq savedirectory (merge-pathnames folder path))
    (setq num 1)
    (while (file-directory-p savedirectory)
      (setq foldername (format nil "~A_~2,'0D" folder num))
      (setq savedirectory (merge-pathnames foldername path))
      (incf num))
    (create-directory savedirectory)
    ;(setq savefile (merge-pathnames "make_lisp_html" savedirectory))
    ;(write-file savefile)
    savedirectory)
  )

(defun make-lisp-to-html-css ()
  (interactive)
  (make-lisp-to-html t)
  )

(defun make-lisp-to-html (&optional cssfile)
  (interactive)
  (make-lisp-to-html-file nil nil cssfile)
  (if cssfile
      (make-style-lisp-css-file))
  (message "finish - make html file - lisp: desktop")
  )

(defun make-lisp-to-html-css-buffer-all ()
  (interactive)
  (make-lisp-to-html-buffer-all t)
  )

(defun make-lisp-to-html-buffer-all (&optional cssfile)
  (interactive)
  (long-operation
    (setq path (make-lisp-to-html-save-directory))
    (dolist (buffer (buffer-list))
      (let ((bufname (buffer-name buffer)))
	(unless (string-match "^ " bufname)
	  (make-lisp-to-html-file buffer path cssfile))))
    (if cssfile
	(make-style-lisp-css-file path))
    (message "finish - make html file all - lisp: ~S" path))
  )

(defun make-lisp-to-html-file (&optional buffer path cssfile)
  (interactive)
  (let (newbuffer)
    (unless buffer
      (setq buffer (selected-buffer)))
    (set-buffer buffer)
    (setq title (pathname-name (buffer-name buffer)))
    ;(string-trim "*" title )
    ;(setq filename (format nil "~A.htm" (buffer-name buffer))) ;;or .html
    (setq filename (format nil "~A.htm" title)) ;;or .html
    (setq filename (substitute-string filename "*" "-"))
    (setq newbuffer (create-new-buffer filename))

    ;;insert buffer
    (with-output-to-buffer (newbuffer)
      (save-excursion
	(set-buffer newbuffer)
	(goto-char (point-min))
	(insert-lisp-html)
	(insert-lisp-head title cssfile)

	(goto-char (point-max))
	(insert-lisp-body buffer newbuffer)

	(set-buffer newbuffer)
	(goto-char (point-max))
	(insert-lisp-html-copyright)
	
	(goto-char (point-max))
	(insert-lisp-html-end)
	)
      )

    ;;save
    (unless path
      ;(setq path (directory-namestring (merge-pathnames "xyzzy.exe" (si:system-root))))
      (setq path (map-backslash-to-slash (get-special-folder-location :desktop))))
    (setq savefile (merge-pathnames filename path))
    (set-buffer newbuffer)
    (write-file savefile)
    (when newbuffer
      (delete-buffer newbuffer))
    ;(add-history savefile '*minibuffer-file-name-history*)
    )
  )

;;;<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
(defun insert-lisp-html ()
  (setq times (format-date-string " [%Y-%m-%d]%H:%M:%S(%Z)" (get-universal-time)))
  (format t "~A~S~A~%~A~A~A~A~%~A~%"
	  "<!DOCTYPE HTML PUBLIC " "-//W3C//DTD HTML 4.01 Transitional//EN" ">"
	  "<!--This file created by " *lisp-html-name-created* times "-->"
	  "<HTML>")
  )

;;;<HTML lang="ja">
;;;Shift_JIS x-jp x-euc-jp iso-2022-jp us-ascii UTF-8
(defun insert-lisp-head (title cssfile)
  (format t "~A~%~A~S~A~%~A~S~A~S~A~%~A~S~A~S~A~%"
	  "<HEAD>"
	  "<META NAME=GENERATOR CONTENT=" *lisp-html-name-generator* ">"
	  "<META HTTP-EQUIV=" "Content-Type" " CONTENT=" "text/html;CHARSET=Shift_JIS" ">"
	  "<META HTTP-EQUIV=" "Content-Style-Type" " CONTENT=" "text/css" ">")
  (if cssfile
      (style-lisp-css-file)
    (style-lisp-css))
  (format t "~A~A~A~%~A~%"
	  "<TITLE>" title "</TITLE>"
	  "</HEAD>")
  )

(defun style-lisp-css ()
  (setq style (get-lisp-html-style 1))
  (format t "~A" style)
  ;(insert style)
  )

(defun style-lisp-css-file ()
  (setq style (get-lisp-html-style 2))
  (format t "~A" style)
  ;(insert style)
  )

(defun make-style-lisp-css-file (&optional path)
  (let (newbuffer)
    (setq filename "stylelisp.css")
    (setq newbuffer (create-new-buffer filename))
    (set-buffer newbuffer)
    (setq style (get-lisp-html-style 3))
    ;(format t "~A" style)
    (insert style)

    (unless path
      ;(setq path (directory-namestring (merge-pathnames "xyzzy.exe" (si:system-root))))
      (setq path (map-backslash-to-slash (get-special-folder-location :desktop))))
    (setq savefile (merge-pathnames filename path))
    (set-buffer newbuffer)
    (write-file savefile)
    (when newbuffer
      (delete-buffer newbuffer))
    ;(add-history savefile '*minibuffer-file-name-history*)
    )
  )

(defun insert-lisp-link (buffer)
  (setq concatlink (get-lisp-html-link buffer))
  (format t "~A" concatlink)
  (if *lisp-convert-indent-space*
      (format t "~A~%" "<br><br>")
    (format t "~%~%"))
  )
#|
(if *lisp-convert-indent-space*
    (format t "~A~A~S~A~A~A~A~%"
	    "&lt;&lt; " "<a href=" *lisp-html-link-href* ">" *lisp-html-link-name* "</a>" "<br><br>")
  (format t "~A~A~S~A~A~A~%~%"
	  "&lt;&lt; " "<a href=" *lisp-html-link-href* ">" *lisp-html-link-name* "</a>"))
|#

(defun insert-lisp-body (buffer newbuffer)
  (if *lisp-convert-indent-space*
      (format t "~A~%" "<BODY>")
    (format t "~A~%~A~%" "<BODY>" "<PRE>"))
  (insert-lisp-link buffer)
  (convert-lisp-html-char buffer newbuffer)
  )

(defun insert-lisp-html-copyright ()
  (when *lisp-html-copyright*
    (setq copyright (format nil "~%~A~A~A~%"
			    "<P><CENTER>Copyright &#169; "
			    *lisp-html-name-copyright*
			    ". All Rights Reserved.</CENTER></P>"))
    (insert copyright))
  )
;;(insert (format-date-string "%Y" (get-universal-time)))

(defun insert-lisp-html-end ()
  (if *lisp-convert-indent-space*
      (setq htmend (format nil "~%~A~%" "</BODY></HTML>"))
    (setq htmend (format nil "~%~A~%~A~%" "<PRE>" "</BODY></HTML>")))
  (insert htmend)
  )
;;;(format t "~%~A~%" "</BODY></HTML>");;cannot insert end

;;;;;;;;;;;;;;;;insert-lisp-body
(defun convert-lisp-html-char (buffer newbuffer)
  (set-buffer buffer)
  (goto-char (point-min))
  (setq bufferstring (buffer-substring (progn
					 (goto-char (point-min))
					 (point))
				       (progn
					 (goto-char (point-max))
					 (point))))

  (set-buffer newbuffer)
  (setq spoint (progn
		 (goto-char (point-max))
		 (point)))
  (insert bufferstring)

  ;;convert &<>" ;;comment lisp 1
  (goto-char spoint)
  (setq commentp nil)
  (setq f nil)
  (while (scan-buffer "\\([&<>\"\;]\\)" :regexp t :no-dup f)
    (cond
     ((char= (following-char) (character "&"))
      (delete-char 1)
      (insert "&amp;")
      (forward-char -1))
     ((char= (following-char) (character "<"))
      (delete-char 1)
      (insert "&lt;")
      (forward-char -1))
     ((char= (following-char) (character ">"))
      (delete-char 1)
      (insert "&gt;")
      (forward-char -1))
     ((char= (following-char) (character "\""))
      (unless (char= (preceding-char) (character "\\"))
	(if commentp
	    (setq commentp nil)
	  (setq commentp t)))
      (delete-char 1)
      (insert "&quot;")
      (forward-char -1))
     ;;comment lisp 1
     ((char= (following-char) (character "\;"))
      (unless commentp
	(insert "<span class=\"comment\">")
	(setq sp (point))
	(goto-eol)
	(setq ep (point))
	(goto-char sp)
	(setq f nil)
	(while (scan-buffer "\\([&<>\"]\\)" :regexp t :no-dup f :limit ep)
	  (cond
	   ((char= (following-char) (character "&"))
	    (delete-char 1)
	    (insert "&amp;")
	    (forward-char -1))
	   ((char= (following-char) (character "<"))
	    (delete-char 1)
	    (insert "&lt;")
	    (forward-char -1))
	   ((char= (following-char) (character ">"))
	    (delete-char 1)
	    (insert "&gt;")
	    (forward-char -1))
	   ((char= (following-char) (character "\""))
	    (delete-char 1)
	    (insert "&quot;")
	    (forward-char -1))
	   )
	  (setq f t))
	(goto-eol)
	(insert "</span>")))
     )
    (setq f t)
    )

  ;;comment lisp 2
  (goto-char spoint)
  (while (scan-buffer "#\|" :regexp t :no-dup t)
    (insert "<span class=\"comment\">")
    (scan-buffer "\|#" :regexp t :no-dup t)
    (forward-char 2)
    (insert "</span>")
    )

  ;;convert tab to space
  (when *lisp-convert-tab-to-space*
    (goto-char spoint)
    (let ((tab-columns (tab-columns (selected-buffer))))
      (while (scan-buffer "\t")
	(insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	(delete-char))))

  ;;convert indent-space
  (when *lisp-convert-indent-space*
    (unless *lisp-convert-tab-to-space*
      (goto-char spoint)
      (let ((tab-columns (tab-columns (selected-buffer))))
	(while (scan-buffer "\t")
	  (insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	  (delete-char))))

    (goto-char spoint)
    ;(while (scan-buffer "^\\([ \t]\\)" :regexp t)
    (while (scan-buffer "^ " :regexp t :no-dup t)
      (delete-region (point)
		     (progn
		       (skip-chars-forward " \t")
		       (setq ccnum (current-column))
		       (point)))
      (insert "&nbsp;" ccnum))

    ;;convert return
    (goto-char spoint)
    (while (scan-buffer "$" :regexp t :no-dup t) ;or "\n"
      (insert "<br>")))
  )

;;;;;;;;;;;;;;;;PRE
(defun make-lisp-to-html-pre-exchange ()
  (interactive)
  (if *lisp-convert-indent-space*
      (setq *lisp-convert-indent-space* nil)
    (setq *lisp-convert-indent-space* t))
  )

;;;;;;;;;;;;;;;;copyright
(defun make-lisp-to-html-copyright-exchange ()
  (interactive)
  (if *lisp-html-copyright*
      (setq *lisp-html-copyright* nil)
    (setq *lisp-html-copyright* t))
  )

;;;;;;;;;;;;;;;;tool delete-html-char
(defun make-lisp-tool-html-to-text (&optional leavelink)
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)

	;;delete comment for "<" ">" in comment
	(goto-char (point-min))
	(while (scan-buffer "<--" :regexp t)
	  (setq sp (point))
	  (unless (scan-buffer "-->" :regexp t :tail t)
	    (return))
	  (setq ep (point))
	  (delete-region sp ep))

	;;script <SCRIPT language=javascript> "<\\(script \\)+\\([ -]\\)+\\(>\\)"
	(goto-char (point-min))
	(while (scan-buffer "<script " :case-fold t :regexp t)
	  (setq sp (point))
	  (unless (scan-buffer "</script>" :case-fold t :regexp t)
	    (return))
	  (setq ep (point))
	  (delete-region sp (+ ep 9)))

	;;convert return
	(goto-char (point-min))
	(while (scan-buffer "<br>" :case-fold t :regexp t)
	  (insert #\LFD 1)
	  (delete-region (point) (+ (point) 4)))

	;;</P> ;;sȂ΁Hs}BBBǂɂȂāAǂɁH

	;;delete tag
	(goto-char (point-min))
	(while (scan-buffer "<" :regexp t)
	  (setq sp (point))
	  (unless (scan-buffer ">" :regexp t :tail t)
	    (return))
	  (setq ep (point))

	  (if leavelink
	      (progn
		(setq stringtag (buffer-substring sp ep))
		(setq stringhead (substring stringtag 0 (min 3 (length stringtag))))
		(if (or (string-equal "<A " stringhead)
			(string-equal "</A>" stringtag))
		    (progn
		      ;;non
		      )
		  (delete-region sp ep))
		)
	    (delete-region sp ep)
	    )
	  )

	;;convert &<>"
	(goto-char (point-min))
	;(while (replace-buffer "&amp\;" "&" :regexp t))
	;(while (replace-buffer "&lt\;" "<" :regexp t));;loop?
	(while (scan-buffer "&amp;" :regexp t)
	  (delete-char 5)
	  (insert "&"))
	(goto-char (point-min))
	(while (scan-buffer "&lt;" :regexp t)
	  (delete-char 4)
	  (insert "<"))
	(goto-char (point-min))
	(while (scan-buffer "&gt;" :regexp t)
	  (delete-char 4)
	  (insert ">"))
	(goto-char (point-min))
	(while (scan-buffer "&quot;" :regexp t)
	  (delete-char 6)
	  (insert "\""))

	;;convert space
	(goto-char (point-min))
	(while (scan-buffer "&nbsp;" :regexp t)
	  (delete-char 6)
	  (insert #\SPC 1))

	;;delete-blank-lines
	(goto-char (point-min))
	(setq nline (current-line-number))
	(setq count 0)
	(while t
	  (goto-line nline)
	  (delete-blank-lines)
	  (incf nline)
	  (goto-char (point-max))
	  (if (>= nline (current-line-number))
	      (return)))

	;;PRE for leave-link
	(if (and leavelink
		 (null *lisp-convert-indent-space*)) ;;nil is pre
	    (progn
	      (goto-char (point-min))
	      (insert "<PRE>")
	      (insert #\LFD 1)
	      (goto-char (point-max))
	      (insert #\LFD 1)
	      (insert "</PRE>")
	      ))

	)
      )
    )
  )

(defun make-lisp-tool-html-to-text-leave-link ()
  (interactive "*")
  (make-lisp-tool-html-to-text t)
  )

;;;;;;;;;;;;;;;;
;;convert <BR> to return
(defun make-lisp-tool-convert-br-to-return ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	(goto-char (point-min))
	(while (scan-buffer "<br>" :case-fold t :regexp t)
	  (insert #\LFD 1)
	  (delete-region (point) (+ (point) 4))))))
  )

;;insert return to <BR>
(defun make-lisp-tool-convert-return-to-br ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	
	(goto-char (point-min))
	;(while (scan-buffer "$" :regexp t)
	(while (scan-buffer "$" :regexp t :no-dup t) ;or "\n"
	  (insert "<BR>"))
	
	)))
  )

;;convert indent-space to &nbsp;
(defun make-lisp-tool-indent-space-to-&nbsp ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	
	(goto-char (point-min))
	(let ((tab-columns (tab-columns (selected-buffer))))
	  (while (scan-buffer "\t")
	    (insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	    (delete-char))

	  (goto-char (point-min))
	  (while (scan-buffer "^ " :regexp t :no-dup t)
	    (delete-region (point)
			   (progn
			     (skip-chars-forward " \t")
			     (setq ccnum (current-column))
			     (point)))
	    (insert "&nbsp;" ccnum))

	  ))))
  )
    
;;convert <P></P> to <BR> for Claris
(defun make-lisp-tool-p-to-br-for-claris ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	
	(goto-char (point-min))
	(while (scan-buffer "<P>" :case-fold t :regexp t)
	  (delete-region (point) (+ (point) 3))
	  ;(char= (preceding-char) (character "^"))
	  (if (and (bolp)
		   (null (bobp)))
	      (progn
		(forward-char -1)
		(delete-char 1))))

	(goto-char (point-min))
	(while (scan-buffer "</P>" :case-fold t :regexp t)
	  (delete-region (point) (+ (point) 4))
	  (if (and (bolp)
		   (null (bobp)))
	      (progn
		(forward-char -1)
		(delete-char 1)))
	  (insert "<BR>"))

	)))
  )

;;;<PRE> to &nbsp; <BR>
(defun make-lisp-tool-pre-to-&nbsp-br ()
  (interactive "*")
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)

	(goto-char (point-min))
	(let ((tab-columns (tab-columns (selected-buffer))))
	  (while (scan-buffer "\t")
	    (insert #\SPC (- tab-columns (rem (current-column) tab-columns)))
	    (delete-char))

	  (goto-char (point-min))
	  (while (scan-buffer "^ " :regexp t :no-dup t)
	    (delete-region (point)
			   (progn
			     (skip-chars-forward " \t")
			     (setq ccnum (current-column))
			     (point)))
	    (insert "&nbsp;" ccnum))

	  (goto-char (point-min))
	  (while (scan-buffer "$" :regexp t :no-dup t) ;or "\n"
	    (insert "<BR>"))

	  ))))
  )

;;;;;;;;;;;;;;;;menu
(export '(*make-html-lisp-menus*
	  init-make-html-lisp-menu
	  ))

(defvar *make-html-lisp-menus* nil)

(defun init-make-html-lisp-menu ()
  (or *make-html-lisp-menus*
      (setq *make-html-lisp-menus* (create-popup-menu)))

  (setq *make-html-lisp-menus*
	(define-popup-menu
	  (:item nil "htmlŕۑlispp(&S)"
	   'make-lisp-to-html)
	  (:item nil "htmlŕۑlisppcss쐬(&C)"
	   'make-lisp-to-html-css)
	  :sep
	  (:item nil "htmlŕۑlisppFSĂޯ̧(&V)"
	   'make-lisp-to-html-buffer-all)
	  (:item nil "htmlŕۑlisppcss쐬FSĂޯ̧(&W)"
	   'make-lisp-to-html-css-buffer-all)
	  :sep
	  (:item nil "PRE`(&P)"
	   'make-lisp-to-html-pre-exchange
	   #'(lambda () (unless *lisp-convert-indent-space* :check)))
	  (:item nil "Copyright(&A)"
	   'make-lisp-to-html-copyright-exchange
	   #'(lambda () (when *lisp-html-copyright* :check)))
	  :sep
	  (:item nil "°فFhtml->text(&T)"
	   'make-lisp-tool-html-to-text)
	  (:item nil "°فFhtml->textFݸtag͎c(&L)"
	   'make-lisp-tool-html-to-text-leave-link)
	  :sep
	  (:item nil "°فF<BR>->s"
	   'make-lisp-tool-convert-br-to-return)
	  (:item nil "°فFs-><BR>"
	   'make-lisp-tool-convert-return-to-br)
	  (:item nil "°فF->&nbsp"
	   'make-lisp-tool-indent-space-to-&nbsp)
	  (:item nil "°فF<P></P>-><BR>"
	   'make-lisp-tool-p-to-br-for-claris)
	  (:item nil "°فF<PRE>->&nbsp<BR>"
	   'make-lisp-tool-pre-to-&nbsp-br)
	  )
	)
  )

;;;;;;;;;;;;;;;; }j[U@insert menu tools °
(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (init-make-html-lisp-menu)
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::tools)))
		(setq ip -1)
		(while (get-menu menu (incf ip) t))

		(insert-menu-separator menu ip 'make-html-lisp-sep)
		(insert-popup-menu menu (incf ip) *make-html-lisp-menus* "html쐬lispp(&Y)")
		)
	      )
	  )

