;;; lisp file for xyzzy ver0.2.2.233
;;; word-count.l ver0.0.0.0.2 // crayonzen [2005-02-26]08:02:24(+0900)

;// how-to: load
;//       : write in .xyzzy or siteinit.l (cut a semicolon ;)
;(load-library "word-count")

(provide "word-count")

(in-package "editor")

(export '(word-count
	  ))

;[hJEg@傫͖̂
(defun word-count ()
  (interactive)
  (long-operation
    (cond ((pre-selection-p)
	   (setq from (selection-mark))
	   (setq to (selection-point)))
	  (t
	   (setq from (point-min))
	   (setq to (point-max))))
    (if (> from to)
	(rotatef from to))
    (setq bufsize (buffer-size))
    (setq pmax (point-max))
    (setq select1 (- to from))

    (save-excursion
      (save-restriction
	(narrow-to-region from to)
	;n1
	(goto-char (point-max))
	(setq maxn1 (current-line-number))
	(goto-char (point-min))
	(setq n1 (current-line-number))
	(setq n1 (- maxn1 n1))

	(let ((e1 0)
	      (t1 0)
	      (s1 0)
	      (s2 0)
	      (f nil))
	  (while (scan-buffer "\\([\t@\X0020-\X00ff]\\)" :regexp t :no-dup f)
	    (cond
	     ((char= (following-char) #\TAB)
	      (incf t1))
	     ((char= (following-char) (character " "))
	      (incf s1))
	     ((char= (following-char) (character "@"))
	      (incf s2))
	     )
	    (incf e1)
	    (message "ײ: ~S / ~S ߲: ~S" (current-line-number) maxn1 (point))
	    (setq f t))
	  (setq e1 (- e1 t1 s2))
	  (setq j1 (- select1 n1 e1 t1))
	  (setq select2 (- select1 n1))
	  (msgbox "ޯ̧ށF~S~%ޯ̧F~S~%~%I𕶎(-s)F~S~%~%SI𕶎F~S~%sF~S~%pF~S~%SpF~S~%^uF~S~%~%p󔒁F~S~%Sp󔒁F~S~%" bufsize pmax select2 select1 n1 e1 j1 t1 s1 s2)
	  ;(message "~d̕񂪂܂" count)
	  select2)
	)
      )
    )
  )

;[hJEg@test a 傫͖̂
(defun word-count-selection-a ()
  (interactive)
  (cond ((pre-selection-p)
	 (word-count (selection-mark) (selection-point)))
	((mark t)
	 (word-count-a (mark nil) (point)))
	(t
	 (word-count-a (point-min) (point-max))))
  )

(defun word-count-a (&optional (from (point-min)) (to (point-max)) )
  (interactive)
  (long-operation
    (if (> from to)
	(rotatef from to))
    (setq bufsize (buffer-size))
    (setq pmax (point-max))
    (setq select1 (- to from))
    (save-excursion
      (save-restriction
	(narrow-to-region from to)

	;n1
	(goto-char (point-min))
	(setq n1 (current-line-number))
	(goto-char (point-max))
	(setq maxn1 (current-line-number))
	(setq n1 (- maxn1 n1))
	#|
(setq n1 0)
(while (not (eobp))
  (when (scan-buffer "\n" :regexp t)
    (incf n1))
  (forward-char)
  )
|#

	;e1
	(goto-char (point-min))
	(setq e1 0)
	(setq t1 0)
	(setq s1 0)
	(setq s2 0)
	(while (not (eobp))
	  ;(when (scan-buffer "\\([\X0020-\X00ff]\\)" :regexp t)
	  (when (scan-buffer "\\([\t@\X0020-\X00ff]\\)" :regexp t)
	    (cond
	     ((char= (following-char) #\TAB)
	      (incf t1))
	     ((char= (following-char) (character " "))
	      (incf s1))
	     ((char= (following-char) (character "@"))
	      (incf s2))
	     )
	    (incf e1)
	    )
	  (forward-char)
	  (message "ײ: ~S / ~S ߲: ~S" (current-line-number) maxn1 (point))
	  )
	;e1
	(setq e1 (- e1 t1 s2))
	#|
;t1 s1 s2
(goto-char (point-min))
(setq t1 0)
(setq s1 0)
(setq s2 0)
(while (not (eobp))
  (when (scan-buffer "\([ \t@]\)" :regexp t)
    (cond
     ((char= (following-char) #\TAB)
      (incf t1))
     ((char= (following-char) (character " "))
      (incf s1))
     ((char= (following-char) (character "@"))
      (incf s2))
     )
    (forward-char)
    )
  )
|#
	;j1
	(setq j1 (- select1 n1 e1 t1))
	(setq select2 (- select1 n1))

	))
    )
  (msgbox "ޯ̧ށF~S~%ޯ̧F~S~%~%I𕶎(-s)F~S~%~%SI𕶎F~S~%sF~S~%pF~S~%SpF~S~%^uF~S~%~%p󔒁F~S~%Sp󔒁F~S~%" bufsize pmax select2 select1 n1 e1 j1 t1 s1 s2)
  t)

(add-hook '*init-app-menus-hook*
	  #'(lambda ()
	      (when (and *app-menu*
			 (setq menu (get-menu *app-menu* 'ed::edit)))
		(add-menu-separator menu 'word-count-sep)
		(add-menu-item menu 'word-count-tag
				"ܰ޶āF傫͖̂(&W)" 'word-count)
		)))

;;;;;;;;;;;;;;;; }j[Q@insert menu edit ҏW
;;(add-hook '*init-app-menus-hook*
;;	  #'(lambda ()
;;	      (when (and *app-menu*
;;			 (setq menu (get-menu *app-menu* 'ed::edit)))
;;		(setq ip -1)
;;		(while (get-menu menu (incf ip) t))
;;
;;		(insert-menu-separator menu ip 'word-count-sep)
;;		(insert-menu-item menu (incf ip) 'wc-tag
;;				  "ܰ޶āF傫͖̂(&W)" 'word-count)
;;		)
;;	      )
;;	  )
